import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class GeneraClave{
   public static void main(String[] args){
 
      if (args.length!=2){
          System.out.println("\nNumero incorrecto de entradas.");
          System.out.println("Uso:");
          System.out.println("java GeneraClave algoritmo ficheroClave\n");
      }else{
         try{
            KeyGenerator keyGen = KeyGenerator.getInstance(args[0]);
            SecureRandom aleat = new SecureRandom();
            keyGen.init(aleat);
            SecretKey clave = keyGen.generateKey();
   
            // Escritura de la clave en un ObjectOutputStream
         
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(args[1]));
            out.writeObject(clave);
            out.close();
         }catch(IOException e){
            System.err.println("Error E/S");
         }catch(NoSuchAlgorithmException e){
            System.err.println("Algoritmo de codificacion inexistente");
         }
      }

   }
}