import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class Desencripta{
   public static void main(String[] args){
      // Modo de operacion: desencriptar
      int modo = Cipher.DECRYPT_MODE;
      
      if (args.length!=4){
          System.out.println("\nNumero incorrecto de entradas.");
          System.out.println("Uso:");
          System.out.println("java Desencripta algoritmo ficheroClave ficheroCodificado ficheroDecodificado\n");               
      }else{
      
         try{
         
            // Lectura de la clave
            ObjectInputStream cl = new ObjectInputStream(new FileInputStream(args[1]));
            Key clave = (Key)cl.readObject();
            cl.close();
            
            InputStream in = new FileInputStream(args[2]);
            OutputStream out = new FileOutputStream(args[3]);
            
            Cipher codificador = Cipher.getInstance(args[0]);
            codificador.init(modo,clave);
            
            Cifra.cifra(in,out,codificador); 
            in.close();
            out.close();
         }catch(IOException e){
            System.err.println("Error E/S");
         }catch(GeneralSecurityException e){
            System.err.println("Error en el algoritmo de encriptacion.");
         }catch(ClassNotFoundException e){
            System.err.println("Error en la recuperacion de la clave");
         }
      }
   }
      
}